﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

using Flash.External;

namespace WindowsFormsApplication1
{
    public partial class Form1 : Form
    {
        private ExternalInterfaceProxy proxy;
        public Form1()
        {
            InitializeComponent();

            // swfを読み込んで配置。
            String swfPath = System.IO.Directory.GetCurrentDirectory() + "\\example.swf";
            axShockwaveFlash1.LoadMovie(0, swfPath);

            // どのswfと送受信するためのproxyかを登録する。
            proxy = new ExternalInterfaceProxy(axShockwaveFlash1);

            // ASから呼ばれた時に実行する関数を登録する。
            proxy.ExternalInterfaceCall += new ExternalInterfaceCallEventHandler(proxy_ExternalInterfaceCall);

        }

        #region ASから呼ばれると、実行される関数。
        private object proxy_ExternalInterfaceCall(object sender, ExternalInterfaceCallEventArgs e)
        {
            // デバッグ用。呼ばれた関数名。
            System.Diagnostics.Debug.WriteLine(e.FunctionCall.FunctionName);

            // テキストボックスに書き込みへ。
            addText((string)e.FunctionCall.Arguments[0], (string)e.FunctionCall.Arguments[1]);

            return null;
        }
        #endregion

        #region AS上の関数を呼び出します。
        private void button1_Click(object sender, EventArgs e)
        {
            // AS上の関数を引数つきで実行
            proxy.Call("asFunction", textBox1.Text, textBox2.Text);

            // テキストボックスに書き込みへ。
            addText(textBox1.Text, textBox2.Text);

            textBox2.Text = "";
        }
        #endregion

        #region テキストボックスに書き込みます。
        private void addText(string name, string message)
        {
            textBox3.Text += name + ":" + message + System.Environment.NewLine;
        }
        #endregion

    }
}
